Public Class EvalFunctions
    ' --------------------------------------------------------------- SLOTS
    Function slot(ByVal value As Double) As Double
        Return Slots.ReadSlot_NoNan(CInt(value))
    End Function

    ' --------------------------------------------------------------- MATH
    Function sin(ByVal v As Double) As Double
        Return Math.Sin(v)
    End Function
    Function cos(ByVal v As Double) As Double
        Return Math.Cos(v)
    End Function
    Function asin(ByVal v As Double) As Double
        Return Math.Asin(v)
    End Function
    Function acos(ByVal v As Double) As Double
        Return Math.Acos(v)
    End Function
    Function tan(ByVal v As Double) As Double
        Return Math.Tan(v)
    End Function
    Function atan(ByVal v As Double) As Double
        Return Math.Atan(v)
    End Function
    Function atan2(ByVal v1 As Double, ByVal v2 As Double) As Double
        Return Math.Atan2(v1, v2)
    End Function
    Function sqrt(ByVal v1 As Double) As Double
        Return Math.Sqrt(v1)
    End Function
    Function abs(ByVal v1 As Double) As Double
        Return Math.Abs(v1)
    End Function
    Function sign(ByVal v1 As Double) As Double
        Return Math.Sign(v1)
    End Function

    Function pow(ByVal v1 As Double, ByVal v2 As Double) As Double
        Return Math.Pow(v1, v2)
    End Function
    Function Exp(ByVal v As Double) As Double
        Return Math.Pow(Math.E, v)
    End Function
    Function Exp2(ByVal v As Double) As Double
        Return Math.Pow(2, v)
    End Function
    Function Exp10(ByVal v As Double) As Double
        Return Math.Pow(10, v)
    End Function
    Function Log(ByVal v As Double) As Double
        Return Math.Log(v, Math.E)
    End Function
    Function Log2(ByVal v As Double) As Double
        Return Math.Log(v, 2)
    End Function
    Function Log10(ByVal v As Double) As Double
        Return Math.Log(v, 10)
    End Function

    ' --------------------------------------------------------------- 
    Function int(ByVal value As Double) As Double
        Return Microsoft.VisualBasic.Int(value)
    End Function
    Function round(ByVal value As Double) As Double
        Return Math.Round(value)
    End Function
    Function mid(ByVal str As String, ByVal index As Double, Optional ByVal len As Double = 999999) As String
        If str = "" Or str Is Nothing Or index <= 0 Then Return ""
        Return Microsoft.VisualBasic.Mid(str, CInt(index), CInt(len))
    End Function
    Function len(ByVal str As String) As Double
        Return Microsoft.VisualBasic.Len(str)
    End Function
    Function trim(ByVal str As String) As String
        Return Microsoft.VisualBasic.Trim(str)
    End Function
    ' --------------------------------------------------------------- STRINGS
    Function padleft(ByVal str As String, ByVal places As Double) As String
        Return str.PadLeft(CInt(places))
    End Function
    Function padright(ByVal str As String, ByVal places As Double) As String
        Return str.PadRight(CInt(places))
    End Function
    Function str(ByVal value As Object, Optional ByVal style As String = "") As String
        Return Microsoft.VisualBasic.Format(value, style).Replace(",", ".")
    End Function
    Function format(ByVal value As Object, Optional ByVal style As String = "") As String
        Return Microsoft.VisualBasic.Format(value, style).Replace(",", ".")
    End Function
    Function ucase(ByVal value As String) As String
        Return Microsoft.VisualBasic.UCase(value)
    End Function
    Function lcase(ByVal value As String) As String
        Return Microsoft.VisualBasic.LCase(value)
    End Function
    Function wcase(ByVal value As String) As String
        If len(value) = 0 Then Return ""
        Return Microsoft.VisualBasic.UCase(value.Substring(0, 1)) & _
              Microsoft.VisualBasic.LCase(value.Substring(1))
    End Function
    Function chars(ByVal str As String, ByVal repetitions As Double) As String
        If str = "" Or str Is Nothing Or repetitions <= 0 Then Return ""
        Return Microsoft.VisualBasic.StrDup(CInt(repetitions), str)
    End Function
    Function Replace(ByVal str As String, ByVal oldStr As String, ByVal newStr As String) As String
        Return str.Replace(oldStr.ToString, newStr.ToString)
    End Function

    ' --------------------------------------------------------------- CONVERSIONS
    Function chr(ByVal n As Double) As String
        Return ChrW(CInt(n))
    End Function
    Function asc(ByVal s As String) As Double
        s = s.Replace("""", "")
        If s = "" Then Return 0
        Return AscW(s)
    End Function
    Function bin(ByVal n As Double) As String
        Return Convert.ToString(CInt(n), 2)
    End Function
    Function frombin(ByVal s As String) As Double
        s = s.Replace("""", "")
        If s = "" Then Return 0
        Return Convert.ToInt32(s, 2)
    End Function
    Function hex(ByVal n As Double) As String
        Return Convert.ToString(CInt(n), 16).ToUpper
    End Function
    Function fromhex(ByVal s As String) As Double
        s = s.Replace("""", "")
        If s = "" Then Return 0
        Return Convert.ToInt32(s, 16)
    End Function

    ' --------------------------------------------------------------- CONSTANTS
    Function crlf() As String
        Return vbCrLf
    End Function
    Function cr() As String
        Return vbCr
    End Function
    Function lf() As String
        Return vbLf
    End Function
    Function nbsp() As String
        Return chr(160)
    End Function
    Function tab() As String
        Return vbTab
    End Function
    Function math_pi() As Double
        Return Math.PI
    End Function
    Function math_e() As Double
        Return Math.E
    End Function

    ' --------------------------------------------------------------- DATE AND TIME
    Function now() As DateTime
        Return Microsoft.VisualBasic.Now
    End Function
    Function today() As DateTime
        Return Microsoft.VisualBasic.Today
    End Function
    Function [date](ByVal year As Double, ByVal month As Double, ByVal day As Double) As DateTime
        Return New Date(CInt(year), CInt(month), CInt(day))
    End Function

    ' --------------------------------------------------------------- STOPWATCH
    Function elapsedtime() As Double
        Return StartTime.Elapsed.TotalSeconds
    End Function

    ' --------------------------------------------------------------- RND
    Function rnd() As Double
        Microsoft.VisualBasic.Randomize()
        Return Microsoft.VisualBasic.Rnd()
    End Function

    ' --------------------------------------------------------------- COM
    Function com_status() As String
        Return COM_GetStatus()
    End Function
    Function com_received() As String
        Return COM_GetReceivedBuffer()
    End Function
    Function com_portnames() As String
        Dim sa() As String = COM_GetPortNames()
        Dim names As String = ""
        For Each s As String In sa
            names += s + " "
        Next
        Return names.Trim
    End Function

    ' -------------------------------------------------------------------------------------------------
    '  GET SEPARATED STRINGS 
    '  - The default separator default is a single space
    '  - Valid separators are single chars or strings
    ' -------------------------------------------------------------------------------------------------
    Function GetSeparatedStringCount(ByVal s As String, _
                                     Optional ByVal separator As String = " ") As Double
        '
        Return Split(s, separator).Length
    End Function
    Function GetSeparatedString(ByVal s As String, ByVal n As Double, _
                                Optional ByVal separator As String = " ") As String
        '
        Dim sa() As String = Split(s, separator)

        Dim i As Int32 = CInt(n)
        If i < 0 Or i >= sa.Length Then Return ""
        Return sa(i)
    End Function

End Class

